alter table log add username varchar(50);

CREATE or replace view has_had_membership AS
	select distinct
	  members.*,
	  orgs.id as org_id,
	  orgs.name as org_name,
	  member_types.id as member_type_id,
	  member_types.type as member_type
	from
	  members,
	  orgs,
	  org_members,
	  member_types
	where
	      members.id = org_members.member_id
	  AND org_members.org_id = orgs.id
	  AND org_members.member_type_id = member_types.id
	  AND member_types.org_id = orgs.id 
	  and (
		--
		-- you are a current member if your membership:
		-- - period started before now, and ends after now
		-- - never ends, always existed
		-- - started before now, never ends
		-- - started at unknown, ends after now
			(org_members.start_date < now())
		     or (org_members.start_date is null)
		     or (org_members.start_date<now())
		     or (org_members.start_date is null)
		    )
	  AND member_types.validates_membership = true
	  AND not exists (select member_id from org_members,member_types
		where org_members.member_type_id = member_types.id
		and org_members.member_id = members.id
		and member_types.revokes_membership = true
		and member_types.validates_membership = false
		and (
		--
		-- you are a current member if your membership:
		-- - period started before now, and ends after now
		-- - never ends, always existed
		-- - started before now, never ends
		-- - started at unknown, ends after now
			(org_members.start_date < now()
			  and org_members.expiry > now())
		     or (org_members.start_date is null
			  and org_members.expiry is null)
		     or (org_members.start_date<now()
			  and org_members.expiry is null)
		     or (org_members.start_date is null
			  and org_members.expiry>now())
		    )
		)
	;
 