<?php
$title = "Nominate";
headers(array('title'=>$title,'menu'=>1,
	      'head_extras'=>'<script language="Javascript" src="lib/popupcalendar/calendar.js"></script>',
	      )
	);

if(has_permission(get_member_id($_SESSION['user']),'edit positions'))
  $can_edit = 1;

if(!$_GET['id']) {
  echo '<p class="error">No Election ID specified.</p>';
  exit(0);
}

require_once 'backend/election.inc';

$election = get_election($_GET['id']);

if($election['nominations-status']!='open') {
  echo '<p class="error">Election nominations are closed.</p>';
  exit(0);
}

foreach($election['position'] as $i => $p) {
  $pos[$i] = $p['name'];
}

$nominateform = array('set'=>array('type'=>'fieldset',
				   'legend'=>'Nomination',
				   'fields'=>array(
		      'position'=>array('type'=>'select',
					'label'=>'Position',
					'items'=>$pos
					),
		      'member'=>array('type'=>'text',
				      'label'=>'Email address of Nominee',
				      'required'=>1,
				      'valid'=>array(
						     '$id = get_member_id($val); if(!$id) return false; $m=get_member($id); if($m->email!=$val) return false; return true;'=>'The email address must be that of a current member of the organisation. You may want to check with the person that this email address is the one they registered with.'
						     ),
				      ),
		      'reason'=>array('type'=>'textarea',
				      'label'=>'Reason (optional)',
				      'cols'=>40,
				      'rows'=>5),
		      ),
				   ),
		      );

$errors = validate($nominateform, $_POST);

?>
<h2>Nominate</h2>
<h3><?=$election['name']?></h3>
<p><?=$election['desc']?></p>
<?php
if($errors || $_POST['Nominate']!='Nominate') {
  echo '<div class="stdform">';
  print $errors;
  output_form($nominateform,"nominate","Nominate","post",
	      "&id=".urlencode($_GET['id']));
  echo '</div>';
} else {
  // We have a nomination!
  $result = sql_insert('election_candidate_nomination',
		 array(
		       'election_position_id'=>$_POST['position'],
		       'from_member_id'=>get_member_id($_SESSION['user']),
		       'for_member_id'=>get_member_id($_POST['member']),
		       'reason'=>$_POST['reason'],
		       )
		       );
  if(DB::isError($result)) {
    echo '<p class="error">Error submitting nomination.</p>';
    if($result->getCode()==DB_ERROR_CONSTRAINT
       && strstr($result->getUserInfo(),'election_candidate_nomination_pkey')
       ) {
      echo '<p class="error">You have already nominated this person';
      echo ' for this position.</p>';
    }
  } else {
    echo '<p>Your nomination has been recorded.</p>';
    echo '<p>'.$_POST['member'].' for '.$pos[$_POST['position']].'</p>';

    $sql = "select count(*) as cnt from election_candidate_nomination where"
      ." election_position_id=".$dbh->quote($_POST['position'])." and "
      ." for_member_id=".$dbh->quote(get_member_id($_POST['member']));
my_syslog(LOG_INFO,$sql);
    $result = $dbh->query($sql);
    $row = $result->fetchrow(DB_FETCHMODE_OBJECT);
    if($row->cnt >= $election['num_req_nominations'])
      $can_become_candidate = true;
    else
      $can_become_candidate = false;
    include 'site-messages/election-notify-nominee.inc';
  }
  echo '<p><a href="?page=view-election&id='.$_GET['id'].'">View Election</a>';
  echo '</p>';
}
?>
