<?php

function tokendb_connect () {
  global $tokendb,$config;

  if(!$tokendb) {		// if not logged in
    // Try to connect
    $tokendb = DB::Connect($config['tokendb'],array('persistent' => true));
    
    if(substr($config['tokendb'],0,strlen('sqlite'))=='sqlite') {
      // check if the tokens table exists
      $result = $tokendb->query("select * from sqlite_master ".
				"where (type='table' and name='token');");

      $row = $result->fetchrow(DB_FETCHMODE_ASSOC);
      if(!$row) {			// If not, create it
	$result = $tokendb->query("create table token (token varchar(50),",
				  " member_id int, task varchar(50), ".
				  "expires int, ".
				  "PRIMARY KEY(token,member_id,task))");
	/*
	 * token - the token string - some random (unique) characters
	 * member_id - the ID of the member this is for
	 * task - string of the task that the token is for
	 * expires - the time() of when it expires
	 */
      }
    }
    // remove old tokens
    $result = $tokendb->query("delete from token where expires < ".time());
  }
  return $tokendb;
}

function days_to_seconds ($days) {
  return $days * 24 * 60 * 60;
}

function token_create ($memberid,$task,$days_to_live=2) {
  global $tokendb;

  $token = randomString(rand(10,50));
  $sql = "insert into token values ('$token',";
  $sql.= "$memberid,'$task',";
  $sql.= time()+days_to_seconds($days_to_live).")";
  $result = $tokendb->query($sql);
  return $token;
}

function check_token($token,$task) {
  global $tokendb;

  $sql = "select * from token where ".
    "token=".$tokendb->quote($token).
    " and task='$task'";
  $result = $tokendb->query($sql);
  if (!DB::isError($result)) {
    $row = $result->fetchrow(DB_FETCHMODE_ASSOC);
    if($token==$row['token'])
      return $row['member_id'];
  }
  
  return -1;
}
?>
